/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.35 Revision 1.117
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.35 2009/05/23 01:08:26 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.117 2012/02/09 22:07:34 hwoarang Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
13 11
14inherit eutils multilib toolchain-funcs flag-o-matic versionator 12inherit base eutils multilib toolchain-funcs flag-o-matic versionator
15 13
16IUSE="${IUSE} custom-cxxflags debug pch"
17
18case "${PV}" in
19 4.?.?_rc*)
20 SRCTYPE="${SRCTYPE:-opensource-src}"
21 MY_PV="${PV/_rc/-rc}" 14MY_PV=${PV/_/-}
22 ;; 15MY_P=qt-everywhere-opensource-src-${MY_PV}
23 *) 16
24 SRCTYPE="${SRCTYPE:-opensource-src}" 17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
25 MY_PV="${PV}" 18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
26 ;; 19LICENSE="|| ( LGPL-2.1 GPL-3 )"
27esac 20
28MY_P=qt-x11-${SRCTYPE}-${MY_PV} 21IUSE="aqua debug pch"
22
23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
25 IUSE+=" +exceptions"
26
27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
29fi
30
31DEPEND="dev-util/pkgconfig"
32RDEPEND="
33 !<x11-libs/qt-assistant-${PV}
34 !>x11-libs/qt-assistant-${PV}-r9999
35 !<x11-libs/qt-core-${PV}
36 !>x11-libs/qt-core-${PV}-r9999
37 !<x11-libs/qt-dbus-${PV}
38 !>x11-libs/qt-dbus-${PV}-r9999
39 !<x11-libs/qt-declarative-${PV}
40 !>x11-libs/qt-declarative-${PV}-r9999
41 !<x11-libs/qt-demo-${PV}
42 !>x11-libs/qt-demo-${PV}-r9999
43 !<x11-libs/qt-gui-${PV}
44 !>x11-libs/qt-gui-${PV}-r9999
45 !<x11-libs/qt-multimedia-${PV}
46 !>x11-libs/qt-multimedia-${PV}-r9999
47 !<x11-libs/qt-opengl-${PV}
48 !>x11-libs/qt-opengl-${PV}-r9999
49 !<x11-libs/qt-phonon-${PV}
50 !>x11-libs/qt-phonon-${PV}-r9999
51 !<x11-libs/qt-qt3support-${PV}
52 !>x11-libs/qt-qt3support-${PV}-r9999
53 !<x11-libs/qt-script-${PV}
54 !>x11-libs/qt-script-${PV}-r9999
55 !<x11-libs/qt-sql-${PV}
56 !>x11-libs/qt-sql-${PV}-r9999
57 !<x11-libs/qt-svg-${PV}
58 !>x11-libs/qt-svg-${PV}-r9999
59 !<x11-libs/qt-test-${PV}
60 !>x11-libs/qt-test-${PV}-r9999
61 !<x11-libs/qt-webkit-${PV}
62 !>x11-libs/qt-webkit-${PV}-r9999
63 !<x11-libs/qt-xmlpatterns-${PV}
64 !>x11-libs/qt-xmlpatterns-${PV}-r9999
65"
66
29S=${WORKDIR}/${MY_P} 67S=${WORKDIR}/${MY_P}
30 68
31HOMEPAGE="http://www.qtsoftware.com/"
32SRC_URI="http://download.qtsoftware.com/qt/source/${MY_P}.tar.bz2"
33
34case "${PV}" in
35 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
36 *) ;;
37esac
38
39if version_is_at_least 4.5 ${PV} ; then
40 LICENSE="|| ( LGPL-2.1 GPL-3 )"
41fi
42
43# @FUNCTION: qt4-build_pkg_setup 69# @FUNCTION: qt4-build_pkg_setup
44# @DESCRIPTION: 70# @DESCRIPTION:
45# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 71# Sets up PATH and LD_LIBRARY_PATH.
46qt4-build_pkg_setup() { 72qt4-build_pkg_setup() {
47 # EAPI=2 ebuilds set use-deps, others need this: 73 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
48 if [[ $EAPI != 2 ]]; then 74
49 # Make sure debug setting corresponds with qt-core (bug 258512) 75 # Protect users by not allowing downgrades between releases
50 if [[ $PN != "qt-core" ]]; then 76 # Downgrading revisions within the same release should be allowed
51 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 77 if has_version '>'${CATEGORY}/${P}-r9999; then
52 ~x11-libs/qt-core-${PV} debug" 78 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
79 eerror "Sanity check to keep you from breaking your system:"
80 eerror " Downgrading Qt is completely unsupported and will break your system!"
81 die "aborting to save your system"
82 else
83 ewarn "Downgrading Qt is completely unsupported and will break your system!"
53 fi 84 fi
85 fi
54 86
55 # Check USE requirements 87 if [[ ${PN} == "qt-webkit" ]]; then
56 qt4-build_check_use 88 eshopts_push -s extglob
89 if is-flagq '-g?(gdb)?([1-9])'; then
90 echo
91 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
92 ewarn "You may experience really long compilation times and/or increased memory usage."
93 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
94 ewarn "For more info check out bug #307861"
95 echo
57 fi 96 fi
58 # Set up installation directories 97 eshopts_pop
59 QTBASEDIR=/usr/$(get_libdir)/qt4 98 fi
60 QTPREFIXDIR=/usr
61 QTBINDIR=/usr/bin
62 QTLIBDIR=/usr/$(get_libdir)/qt4
63 QTPCDIR=/usr/$(get_libdir)/pkgconfig
64 QTDATADIR=/usr/share/qt4
65 QTDOCDIR=/usr/share/doc/qt-${PV}
66 QTHEADERDIR=/usr/include/qt4
67 QTPLUGINDIR=${QTLIBDIR}/plugins
68 QTSYSCONFDIR=/etc/qt4
69 QTTRANSDIR=${QTDATADIR}/translations
70 QTEXAMPLESDIR=${QTDATADIR}/examples
71 QTDEMOSDIR=${QTDATADIR}/demos
72 99
73 PLATFORM=$(qt_mkspecs_dir)
74
75 PATH="${S}/bin:${PATH}" 100 PATH="${S}/bin${PATH:+:}${PATH}"
101 if [[ ${CHOST} != *-darwin* ]]; then
76 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 102 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
103 else
104 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
105 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
106 # platform detection. Note: needs to come before any directories to
107 # avoid extract failure.
108 [[ ${CHOST} == *-apple-darwin* ]] && \
109 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
110 ${QT4_EXTRACT_DIRECTORIES}"
111 fi
77 112
113 # Make sure ebuilds use the required EAPI
114 if [[ ${EAPI} != [234] ]]; then
115 eerror "The qt4-build eclass requires EAPI 2,3 or 4 but this ebuild is using"
116 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
117 eerror "fixed. Using qt4-build eclass without EAPI 2,3 or 4 will fail."
118 die "qt4-build eclass requires EAPI 2,3 or 4"
119 fi
120
78 if ! version_is_at_least 4.1 $(gcc-version) ; then 121 if ! version_is_at_least 4.1 $(gcc-version); then
79 ewarn "Using a GCC version lower than 4.1 is not supported!" 122 ewarn "Using a GCC version lower than 4.1 is not supported!"
80 echo
81 ebeep 3
82 fi 123 fi
83
84 if use custom-cxxflags; then
85 echo
86 ewarn "You have set USE=custom-cxxflags, which means Qt will be built with the"
87 ewarn "CXXFLAGS you have set in /etc/make.conf. This is not supported, and we"
88 ewarn "recommend to unset this useflag. But you are free to experiment with it."
89 ewarn "Just do not start crying if it breaks your system, or eats your kitten"
90 ewarn "for breakfast. ;-) "
91 echo
92 fi
93
94} 124}
95 125
96# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 126# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
97# @DESCRIPTION: 127# @DESCRIPTION:
98# Arguments for build_target_directories. Takes the directories, in which the 128# Arguments for build_target_directories. Takes the directories in which the
99# code should be compiled. This is a space-separated list 129# code should be compiled. This is a space-separated list.
100 130
101# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 131# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
102# @DESCRIPTION: 132# @DESCRIPTION:
103# Space separated list including the directories that will be extracted from Qt 133# Space-separated list including the directories that will be extracted from
104# tarball 134# Qt tarball.
105 135
106# @FUNCTION: qt4-build_src_unpack 136# @FUNCTION: qt4-build_src_unpack
107# @DESCRIPTION: 137# @DESCRIPTION:
108# Unpacks the sources 138# Unpacks the sources.
109qt4-build_src_unpack() { 139qt4-build_src_unpack() {
110 local target targets licenses 140 setqtenv
111 if version_is_at_least 4.5 ${PV} ; then 141
112 licenses="LICENSE.GPL3 LICENSE.LGPL" 142 local tarball="${MY_P}.tar.gz" target= targets=
113 else 143 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
114 licenses="LICENSE.GPL2 LICENSE.GPL3"
115 fi
116 for target in configure ${licenses} projects.pro \
117 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 144 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
118 ${QT4_EXTRACT_DIRECTORIES}; do 145 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
146 do
119 targets="${targets} ${MY_P}/${target}" 147 targets+="${MY_P}/${target} "
120 done 148 done
121 149
122 echo tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 150 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
123 tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 151 tar -xzf "${DISTDIR}/${tarball}" ${targets}
124 152 eend $? || die "failed to unpack"
125 case "${PV}" in
126 4.4.?)
127 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
128 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
129 ;;
130 esac
131
132 # Be backwards compatible for now
133 if [[ $EAPI != 2 ]]; then
134 qt4-build_src_prepare
135 fi
136} 153}
137 154
155# @ECLASS-VARIABLE: PATCHES
156# @DEFAULT_UNSET
157# @DESCRIPTION:
158# PATCHES array variable containing all various patches to be applied.
159# This variable is expected to be defined in global scope of ebuild.
160# Make sure to specify the full path. This variable is utilised in
161# src_unpack/src_prepare phase, based on EAPI.
162#
163# @CODE
164# PATCHES=( "${FILESDIR}/mypatch.patch"
165# "${FILESDIR}/patches_folder/" )
166# @CODE
138 167
139# @FUNCTION: qt4-build_src_prepare 168# @FUNCTION: qt4-build_src_prepare
140# @DESCRIPTION: 169# @DESCRIPTION:
141# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 170# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
142# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 171# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
143qt4-build_src_prepare() { 172qt4-build_src_prepare() {
173 setqtenv
144 cd "${S}" 174 cd "${S}"
145 175
176 if version_is_at_least "4.7"; then
177 # fix libX11 dependency on non X packages
178 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
179 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
180
181 qt_assistant_cleanup
182 fi
183
184 if use aqua; then
185 # provide a proper macx-g++-64
186 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
187
188 sed -e '/^CONFIG/s:app_bundle::' \
189 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
190 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
191 fi
192
146 if [[ ${PN} != qt-core ]]; then 193 if [[ ${PN} != qt-core ]]; then
147 skip_qmake_build_patch 194 skip_qmake_build
148 skip_project_generation_patch 195 skip_project_generation
149 symlink_binaries_to_buildtree 196 symlink_binaries_to_buildtree
150 fi 197 fi
151 198
152 if ! use custom-cxxflags;then 199 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then
153 # Don't let the user go too overboard with flags. 200 # qmake bus errors with -O2 but -O3 works
154 strip-flags
155 replace-flags -O3 -O2 201 replace-flags -O2 -O3
156 fi 202 fi
157 203
158 # Bug 178652 204 # Bug 178652
159 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 205 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
160 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 206 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
161 append-flags -fno-gcse 207 append-flags -fno-gcse
162 fi 208 fi
163 209
210 if use_if_iuse c++0x; then
211 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
212 ewarn "this is an official standard, some of the reverse dependencies"
213 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
214 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
215 ewarn "disabled."
216 append-flags -std=c++0x
217 fi
218
164 # Unsupported old gcc versions - hardened needs this :( 219 # Unsupported old gcc versions - hardened needs this :(
165 if [[ $(gcc-major-version) -lt "4" ]] ; then 220 if [[ $(gcc-major-version) -lt 4 ]] ; then
166 ewarn "Appending -fno-stack-protector to CXXFLAGS" 221 ewarn "Appending -fno-stack-protector to CXXFLAGS"
167 append-cxxflags -fno-stack-protector 222 append-cxxflags -fno-stack-protector
168 # Bug 253127 223 # Bug 253127
169 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 224 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
170 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 225 -i mkspecs/common/g++.conf || die
171 fi 226 fi
227
228 # Bug 261632
229 if use ppc64; then
230 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
231 append-flags -mminimal-toc
232 fi
233
234 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
235 sed -e "/^SYSTEM_VARIABLES=/i \
236 CC='$(tc-getCC)'\n\
237 CXX='$(tc-getCXX)'\n\
238 CFLAGS='${CFLAGS}'\n\
239 CXXFLAGS='${CXXFLAGS}'\n\
240 LDFLAGS='${LDFLAGS}'\n" \
241 -i configure \
242 || die "sed SYSTEM_VARIABLES failed"
243
244 # Respect CC, CXX, LINK and *FLAGS in config.tests
245 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
246 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
247 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
248 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
249 || die "sed config.tests failed"
250
251 # Strip predefined CFLAGS from mkspecs (bug 312689)
252 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
172 253
173 # Bug 172219 254 # Bug 172219
255 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
256
257 if [[ ${CHOST} == *-darwin* ]]; then
258 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
259 # crippled (by design) :/
260 sed \
174 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 261 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
175 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 262 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
176 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 263 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
177 -e "s:X11R6/::" \ 264 -e "s:-arch\s\w*::g" \
178 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 265 -i mkspecs/common/mac-g++.conf \
266 || die "sed mkspecs/common/mac-g++.conf failed"
179 267
180 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 268 # Fix configure's -arch settings that appear in qmake/Makefile and also
181 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 269 # fix arch handling (automagically duplicates our -arch arg and breaks
182 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 270 # pch). Additionally disable Xarch support.
183 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 271 sed \
272 -e "s:-arch i386::" \
273 -e "s:-arch ppc::" \
274 -e "s:-arch x86_64::" \
275 -e "s:-arch ppc64::" \
276 -e "s:-arch \$i::" \
277 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
278 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
279 -e "s:-Xarch_x86_64::g" \
280 -e "s:-Xarch_ppc64::g" \
281 -i configure mkspecs/common/mac-g++.conf \
282 || die "sed -arch/-Xarch failed"
184 283
284 # On Snow Leopard don't fall back to 10.5 deployment target.
285 if [[ ${CHOST} == *-apple-darwin10 ]] ; then
286 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
287 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
288 -i configure mkspecs/common/mac-g++.conf \
289 || die "sed deployment target failed"
290 fi
291 fi
292
293 # this one is needed for all systems with a separate -liconv, apart from
294 # Darwin, for which the sources already cater for -liconv
295 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then
296 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
297 -i config.tests/unix/iconv/iconv.pro \
298 || die "sed iconv.pro failed"
299 fi
300
301 # we need some patches for Solaris
302 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
303 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
304 # use GCC over SunStudio
305 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
306 # do not flirt with non-Prefix stuff, we're quite possessive
307 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
308 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
309
310 base_src_prepare
185} 311}
186 312
187# @FUNCTION: qt4-build_src_configure 313# @FUNCTION: qt4-build_src_configure
188# @DESCRIPTION: 314# @DESCRIPTION:
189# Default configure phase 315# Default configure phase
190qt4-build_src_configure() { 316qt4-build_src_configure() {
191 317 setqtenv
192 myconf="$(standard_configure_options) ${myconf}" 318 myconf="$(standard_configure_options) ${myconf}"
319
320 # this one is needed for all systems with a separate -liconv, apart from
321 # Darwin, for which the sources already cater for -liconv
322 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \
323 myconf+=" -liconv"
324
325 if use_if_iuse glib; then
326 # use -I, -L and -l from configure
327 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
328 # avoid the -pthread argument
329 myconf+=" ${glibflags//-pthread}"
330 unset glibflags
331 fi
332
333 if use_if_iuse qpa; then
334 ewarn
335 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
336 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
337 ewarn "disable it before reporting any bugs related to this useflag."
338 ewarn
339 myconf+=" -qpa"
340 fi
341
342 if use aqua ; then
343 # On (snow) leopard use the new (frameworked) cocoa code.
344 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then
345 myconf+=" -cocoa -framework"
346
347 # We are crazy and build cocoa + qt3support :-)
348 if use qt3support; then
349 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
350 -i configure || die
351 fi
352
353 # We need the source's headers, not the installed ones.
354 myconf+=" -I${S}/include"
355
356 # Add hint for the framework location.
357 myconf+=" -F${QTLIBDIR}"
358 fi
359 else
360 # freetype2 include dir is non-standard, thus include it on configure
361 # use -I from configure
362 myconf+=" $(pkg-config --cflags freetype2)"
363 fi
193 364
194 echo ./configure ${myconf} 365 echo ./configure ${myconf}
195 ./configure ${myconf} || die "./configure failed" 366 ./configure ${myconf} || die "./configure failed"
367 myconf=""
368
369 prepare_directories ${QT4_TARGET_DIRECTORIES}
196} 370}
197 371
198# @FUNCTION: qt4-build_src_compile 372# @FUNCTION: qt4-build_src_compile
373# @DESCRIPTION:
199# @DESCRIPTION: Actual compile phase 374# Actual compile phase
200qt4-build_src_compile() { 375qt4-build_src_compile() {
201 # Be backwards compatible for now 376 setqtenv
202 if [[ $EAPI != 2 ]]; then
203 qt4-build_src_configure
204 fi
205 377
206 build_directories "${QT4_TARGET_DIRECTORIES}" 378 build_directories ${QT4_TARGET_DIRECTORIES}
379}
380
381# @FUNCTION: qt4-build_src_test
382# @DESCRIPTION:
383# Runs tests only in target directories.
384qt4-build_src_test() {
385 for dir in ${QT4_TARGET_DIRECTORIES}; do
386 emake -j1 check -C ${dir}
387 done
388}
389
390# @FUNCTION: fix_includes
391# @DESCRIPTION:
392# For MacOS X we need to add some symlinks when frameworks are
393# being used, to avoid complications with some more or less stupid packages.
394fix_includes() {
395 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then
396 # Some packages tend to include <Qt/...>
397 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
398
399 # Fake normal headers when frameworks are installed... eases life later on
400 local dest f h
401 for frw in "${D}${QTLIBDIR}"/*.framework; do
402 [[ -e "${frw}"/Headers ]] || continue
403 f=$(basename ${frw})
404 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
405 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
406
407 # Link normal headers as well.
408 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
409 h=$(basename ${hdr})
410 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
411 done
412 done
413 fi
207} 414}
208 415
209# @FUNCTION: qt4-build_src_install 416# @FUNCTION: qt4-build_src_install
210# @DESCRIPTION: 417# @DESCRIPTION:
211# Perform the actual installation including some library fixes. 418# Perform the actual installation including some library fixes.
212qt4-build_src_install() { 419qt4-build_src_install() {
420 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
421 setqtenv
422
213 install_directories "${QT4_TARGET_DIRECTORIES}" 423 install_directories ${QT4_TARGET_DIRECTORIES}
214 install_qconfigs 424 install_qconfigs
215 fix_library_files 425 fix_library_files
426 fix_includes
427
428 # remove .la files since we are building only shared Qt libraries
429 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
430}
431
432# @FUNCTION: setqtenv
433# @INTERNAL
434setqtenv() {
435 # Set up installation directories
436 QTPREFIXDIR=${EPREFIX}/usr
437 QTBINDIR=${EPREFIX}/usr/bin
438 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
439 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
440 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
441 QTHEADERDIR=${EPREFIX}/usr/include/qt4
442 QTPLUGINDIR=${QTLIBDIR}/plugins
443 QTIMPORTDIR=${QTLIBDIR}/imports
444 QTDATADIR=${EPREFIX}/usr/share/qt4
445 QTTRANSDIR=${QTDATADIR}/translations
446 QTSYSCONFDIR=${EPREFIX}/etc/qt4
447 QTEXAMPLESDIR=${QTDATADIR}/examples
448 QTDEMOSDIR=${QTDATADIR}/demos
449 QMAKE_LIBDIR_QT=${QTLIBDIR}
450 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
451
452 PLATFORM=$(qt_mkspecs_dir)
453
454 unset QMAKESPEC
216} 455}
217 456
218# @FUNCTION: standard_configure_options 457# @FUNCTION: standard_configure_options
458# @INTERNAL
219# @DESCRIPTION: 459# @DESCRIPTION:
220# Sets up some standard configure options, like libdir (if necessary), whether 460# Sets up some standard configure options, like libdir (if necessary), whether
221# debug info is wanted or not. 461# debug info is wanted or not.
222standard_configure_options() { 462standard_configure_options() {
223 local myconf="" 463 local myconf="-prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
464 -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} -plugindir ${QTPLUGINDIR}
465 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
466 -datadir ${QTDATADIR} -translationdir ${QTTRANSDIR} -sysconfdir ${QTSYSCONFDIR}
467 -examplesdir ${QTEXAMPLESDIR} -demosdir ${QTDEMOSDIR}
468 -opensource -confirm-license -shared -fast -largefile -stl -verbose
469 -platform $(qt_mkspecs_dir) -nomake examples -nomake demos"
224 470
225 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 471 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
226 472
227 # Disable visibility explicitly if gcc version isn't 4 473 # debug/release
228 if [[ "$(gcc-major-version)" -lt "4" ]]; then
229 myconf="${myconf} -no-reduce-exports"
230 fi
231
232 # precompiled headers doesn't work on hardened, where the flag is masked.
233 if use pch; then 474 if use debug; then
234 myconf="${myconf} -pch" 475 myconf+=" -debug"
235 else 476 else
236 myconf="${myconf} -no-pch" 477 myconf+=" -release"
237 fi 478 fi
238
239 if use debug; then
240 myconf="${myconf} -debug -no-separate-debug-info" 479 myconf+=" -no-separate-debug-info"
241 else 480
242 myconf="${myconf} -release -no-separate-debug-info" 481 # exceptions USE flag
243 fi 482 local exceptions="-exceptions"
483 in_iuse exceptions && exceptions="$(qt_use exceptions)"
484 myconf+=" ${exceptions}"
485
486 # disable RPATH on Qt >= 4.8 (bug 380415)
487 version_is_at_least 4.8 && myconf+=" -no-rpath"
488
489 # precompiled headers don't work on hardened, where the flag is masked
490 myconf+=" $(qt_use pch)"
491
492 # -reduce-relocations
493 # This flag seems to introduce major breakage to applications,
494 # mostly to be seen as a core dump with the message "QPixmap: Must
495 # construct a QApplication before a QPaintDevice" on Solaris.
496 # -- Daniel Vergien
497 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
498
499 use aqua && myconf+=" -no-framework"
244 500
245 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 501 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
246 # $(tc-arch). Therefore we convert it to supported values. 502 # $(tc-arch). Therefore we convert it to supported values.
247 case "$(tc-arch)" in 503 case "$(tc-arch)" in
248 amd64) myconf="${myconf} -arch x86_64" ;; 504 amd64|x64-*) myconf+=" -arch x86_64" ;;
505 ppc-macos) myconf+=" -arch ppc" ;;
249 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 506 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
507 sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
508 x86-macos) myconf+=" -arch x86" ;;
250 x86|x86-*) myconf="${myconf} -arch i386" ;; 509 x86|x86-*) myconf+=" -arch i386" ;;
251 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 510 alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
252 hppa|sh) myconf="${myconf} -arch generic" ;; 511 hppa|sh) myconf+=" -arch generic" ;;
253 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 512 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
254 esac 513 esac
255 514
256 # Bug 261412 Qt configure detects archs by uname
257 case "$(tc-arch)" in
258 ppc) myconf="${myconf} -platform linux-g++-32";;
259 esac
260
261 myconf="${myconf} -stl -verbose -largefile -confirm-license -no-rpath
262 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
263 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
264 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
265 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
266 -demosdir ${QTDEMOSDIR} -silent -fast
267 $([[ ${PN} == qt-xmlpatterns ]] || echo -no-exceptions)
268 -reduce-relocations -nomake examples -nomake demos"
269
270 # Make eclass 4.5.{1,2} ready
271 case "${MY_PV}" in
272 4.5.1 | 4.5.2)
273 myconf="${myconf} -opensource"
274 ;;
275 esac
276
277 echo "${myconf}" 515 echo "${myconf}"
278} 516}
517
518# @FUNCTION: prepare_directories
519# @USAGE: < directories >
520# @INTERNAL
521# @DESCRIPTION:
522# Generates Makefiles for the given list of directories.
523prepare_directories() {
524 for x in "$@"; do
525 pushd "${S}"/${x} >/dev/null || die
526 einfo "Running qmake in: ${x}"
527 # avoid running over the maximum argument number, bug #299810
528 {
529 echo "${S}"/mkspecs/common/*.conf
530 find "${S}" -name '*.pr[io]'
531 } | xargs sed -i \
532 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
533 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
534 || die
535 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
536 popd >/dev/null || die
537 done
538}
539
279 540
280# @FUNCTION: build_directories 541# @FUNCTION: build_directories
281# @USAGE: < directories > 542# @USAGE: < directories >
543# @INTERNAL
282# @DESCRIPTION: 544# @DESCRIPTION:
283# Compiles the code in $QT4_TARGET_DIRECTORIES 545# Compiles the code in the given list of directories.
284build_directories() { 546build_directories() {
285 local dirs="$@"
286 for x in ${dirs}; do 547 for x in "$@"; do
287 cd "${S}"/${x} 548 pushd "${S}"/${x} >/dev/null || die
288 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 549 emake CC="$(tc-getCC)" \
289 emake || die "emake failed" 550 CXX="$(tc-getCXX)" \
551 LINK="$(tc-getCXX)" || die "emake failed"
552 popd >/dev/null || die
290 done 553 done
291} 554}
292 555
293# @FUNCTION: install_directories 556# @FUNCTION: install_directories
294# @USAGE: < directories > 557# @USAGE: < directories >
558# @INTERNAL
295# @DESCRIPTION: 559# @DESCRIPTION:
296# run emake install in the given directories, which are separated by spaces 560# Runs emake install in the given directories, which are separated by spaces.
297install_directories() { 561install_directories() {
298 local dirs="$@"
299 for x in ${dirs}; do 562 for x in "$@"; do
300 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 563 pushd "${S}"/${x} >/dev/null || die
301 emake INSTALL_ROOT="${D}" install || die "emake install failed" 564 emake INSTALL_ROOT="${D}" install || die "emake install failed"
302 popd >/dev/null || die "Can't popd from ${S}/${x}" 565 popd >/dev/null || die
303 done 566 done
304} 567}
305 568
306# @ECLASS-VARIABLE: QCONFIG_ADD 569# @ECLASS-VARIABLE: QCONFIG_ADD
307# @DESCRIPTION: 570# @DESCRIPTION:
308# List options that need to be added to QT_CONFIG in qconfig.pri 571# List options that need to be added to QT_CONFIG in qconfig.pri
309QCONFIG_ADD="${QCONFIG_ADD:-}" 572: ${QCONFIG_ADD:=}
310 573
311# @ECLASS-VARIABLE: QCONFIG_REMOVE 574# @ECLASS-VARIABLE: QCONFIG_REMOVE
312# @DESCRIPTION: 575# @DESCRIPTION:
313# List options that need to be removed from QT_CONFIG in qconfig.pri 576# List options that need to be removed from QT_CONFIG in qconfig.pri
314QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 577: ${QCONFIG_REMOVE:=}
315 578
316# @ECLASS-VARIABLE: QCONFIG_DEFINE 579# @ECLASS-VARIABLE: QCONFIG_DEFINE
317# @DESCRIPTION: 580# @DESCRIPTION:
318# List variables that should be defined at the top of QtCore/qconfig.h 581# List variables that should be defined at the top of QtCore/qconfig.h
319QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 582: ${QCONFIG_DEFINE:=}
320 583
321# @FUNCTION: install_qconfigs 584# @FUNCTION: install_qconfigs
585# @INTERNAL
586# @DESCRIPTION:
322# @DESCRIPTION: Install gentoo-specific mkspecs configurations 587# Install gentoo-specific mkspecs configurations.
323install_qconfigs() { 588install_qconfigs() {
324 local x 589 local x
325 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 590 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
326 for x in QCONFIG_ADD QCONFIG_REMOVE; do 591 for x in QCONFIG_ADD QCONFIG_REMOVE; do
327 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 592 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
328 done 593 done
329 insinto ${QTDATADIR}/mkspecs/gentoo 594 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
330 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 595 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
331 fi 596 fi
332 597
333 if [[ -n ${QCONFIG_DEFINE} ]]; then 598 if [[ -n ${QCONFIG_DEFINE} ]]; then
334 for x in ${QCONFIG_DEFINE}; do 599 for x in ${QCONFIG_DEFINE}; do
335 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 600 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
336 done 601 done
337 insinto ${QTHEADERDIR}/Gentoo 602 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
338 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 603 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
339 fi 604 fi
340} 605}
341 606
342# @FUNCTION: generate_qconfigs 607# @FUNCTION: generate_qconfigs
343# @DESCRIPTION: Generates gentoo-specific configurations 608# @INTERNAL
609# @DESCRIPTION:
610# Generates gentoo-specific qconfig.{h,pri}.
344generate_qconfigs() { 611generate_qconfigs() {
345 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 612 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
346 local x qconfig_add qconfig_remove qconfig_new 613 local x qconfig_add qconfig_remove qconfig_new
347 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 614 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
348 [[ -f ${x} ]] || continue 615 [[ -f ${x} ]] || continue
349 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 616 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
350 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 617 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
351 done 618 done
352 619
353 # these error checks do not use die because dying in pkg_post{inst,rm} 620 # these error checks do not use die because dying in pkg_post{inst,rm}
354 # just makes things worse. 621 # just makes things worse.
355 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 622 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
362 629
363 # generate list of QT_CONFIG entries from the existing list 630 # generate list of QT_CONFIG entries from the existing list
364 # including qconfig_add and excluding qconfig_remove 631 # including qconfig_add and excluding qconfig_remove
365 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 632 for x in $(sed -n 's/^QT_CONFIG +=//p' \
366 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 633 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
367 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 634 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
368 done 635 done
369 636
370 # replace the existing QT_CONFIG list with qconfig_new 637 # replace the existing QT_CONFIG list with qconfig_new
371 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 638 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
372 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 639 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
396 fi 663 fi
397 fi 664 fi
398} 665}
399 666
400# @FUNCTION: qt4-build_pkg_postrm 667# @FUNCTION: qt4-build_pkg_postrm
668# @DESCRIPTION:
401# @DESCRIPTION: Generate configurations when the package is completely removed 669# Regenerate configuration when the package is completely removed.
402qt4-build_pkg_postrm() { 670qt4-build_pkg_postrm() {
403 generate_qconfigs 671 generate_qconfigs
404} 672}
405 673
406# @FUNCTION: qt4-build_pkg_postinst 674# @FUNCTION: qt4-build_pkg_postinst
675# @DESCRIPTION:
407# @DESCRIPTION: Generate configuration, plus throws a message about possible 676# Regenerate configuration, plus throw a message about possible
408# breakages and proposed solutions. 677# breakages and proposed solutions.
409qt4-build_pkg_postinst() { 678qt4-build_pkg_postinst() {
410 generate_qconfigs 679 generate_qconfigs
411 echo
412 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
413 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
414 ewarn "should recompile the packages providing these plugins. Also, make sure you"
415 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
416 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
417 ewarn
418 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
419 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
420 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
421 ewarn "configuration."
422 ewarn
423 ewarn "For more information, see http://doc.trolltech.com/4.4/plugins-howto.html"
424 echo
425} 680}
426 681
427# @FUNCTION: skip_qmake_build_patch 682# @FUNCTION: skip_qmake_build
683# @INTERNAL
428# @DESCRIPTION: 684# @DESCRIPTION:
429# Don't need to build qmake, as it's already installed from qt-core 685# Patches configure to skip qmake compilation, as it's already installed by qt-core.
430skip_qmake_build_patch() { 686skip_qmake_build() {
431 # Don't need to build qmake, as it's already installed from qt-core
432 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 687 sed -i -e "s:if true:if false:g" "${S}"/configure || die
433} 688}
434 689
435# @FUNCTION: skip_project_generation_patch 690# @FUNCTION: skip_project_generation
691# @INTERNAL
436# @DESCRIPTION: 692# @DESCRIPTION:
437# Exit the script early by throwing in an exit before all of the .pro files are scanned 693# Exit the script early by throwing in an exit before all of the .pro files are scanned.
438skip_project_generation_patch() { 694skip_project_generation() {
439 # Exit the script early by throwing in an exit before all of the .pro files are scanned
440 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 695 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
441 -i "${S}"/configure || die "Sed failed"
442} 696}
443 697
444# @FUNCTION: symlink_binaries_to_buildtree 698# @FUNCTION: symlink_binaries_to_buildtree
699# @INTERNAL
445# @DESCRIPTION: 700# @DESCRIPTION:
446# Symlink generated binaries to buildtree so they can be used during compilation 701# Symlinks generated binaries to buildtree, so they can be used during compilation time.
447# time
448symlink_binaries_to_buildtree() { 702symlink_binaries_to_buildtree() {
449 for bin in qmake moc uic rcc; do 703 for bin in qmake moc uic rcc; do
450 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 704 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
451 done 705 done
452} 706}
453 707
454# @FUNCTION: fix_library_files 708# @FUNCTION: fix_library_files
709# @INTERNAL
455# @DESCRIPTION: 710# @DESCRIPTION:
456# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 711# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
457# moves the *.pc-files into the pkgconfig directory 712# moves the *.pc files into the pkgconfig directory.
458fix_library_files() { 713fix_library_files() {
714 local libfile
459 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 715 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
460 if [[ -e ${libfile} ]]; then 716 if [[ -e ${libfile} ]]; then
461 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 717 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
462 fi 718 fi
463 done 719 done
464 720
465 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 721 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
466 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 722 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
467 if [[ -e ${libfile} ]]; then 723 if [[ -e ${libfile} ]]; then
468 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 724 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
469 725
470 # Move .pc files into the pkgconfig directory 726 # Move .pc files into the pkgconfig directory
471 dodir ${QTPCDIR} 727 dodir ${QTPCDIR#${EPREFIX}}
472 mv ${libfile} "${D}"/${QTPCDIR}/ \ 728 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
473 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
474 fi 729 fi
475 done 730 done
476 731
477 # Don't install an empty directory 732 # Don't install an empty directory
478 rmdir "${D}"/${QTLIBDIR}/pkgconfig 733 rmdir "${D}"/${QTLIBDIR}/pkgconfig
479} 734}
480 735
481# @FUNCTION: qt_use 736# @FUNCTION: qt_use
482# @USAGE: < flag > [ feature ] [ enableval ] 737# @USAGE: < flag > [ feature ] [ enableval ]
483# @DESCRIPTION: 738# @DESCRIPTION:
484# This will echo "${enableval}-${feature}" if <flag> is enabled, or 739# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
485# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 740# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
486# will be used for that. If [enableval] is not specified, it omits the 741# will be used for that. If [enableval] is not specified, it omits the
487# assignment-part 742# "-${enableval}" part.
488qt_use() { 743qt_use() {
489 local flag="${1}" 744 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
490 local feature="${1}"
491 local enableval=
492
493 [[ -n ${2} ]] && feature=${2}
494 [[ -n ${3} ]] && enableval="-${3}"
495
496 if use ${flag}; then
497 echo "${enableval}-${feature}"
498 else
499 echo "-no-${feature}"
500 fi
501}
502
503# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
504# @DESCRIPTION:
505# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
506# (eutils.eclass), line per line.
507#
508# Example:
509# @CODE
510# pkg_setup() {
511# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
512# ~x11-libs/qt-gui-${PV} qt3support"
513# qt4-build_check_use
514# }
515# @CODE
516
517# Run built_with_use on each flag and print appropriate error messages if any
518# flags are missing
519
520_qt_built_with_use() {
521 local missing opt pkg flag flags
522
523 if [[ ${1} = "--missing" ]]; then
524 missing="${1} ${2}" && shift 2
525 fi
526 if [[ ${1:0:1} = "-" ]]; then
527 opt=${1} && shift
528 fi
529
530 pkg=${1} && shift
531
532 for flag in "${@}"; do
533 flags="${flags} ${flag}"
534 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
535 flags="${flags}*"
536 else
537 [[ ${opt} = "-o" ]] && return 0
538 fi
539 done
540 if [[ "${flags# }" = "${@}" ]]; then
541 return 0
542 fi
543 if [[ ${opt} = "-o" ]]; then
544 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
545 else
546 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
547 fi
548 return 1
549}
550
551# @FUNCTION: qt4-build_check_use
552# @DESCRIPTION:
553# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
554# USE flags listed.
555#
556# If any of the required USE flags are missing, an eerror will be printed for
557# each package with missing USE flags.
558qt4-build_check_use() {
559 local line missing
560 while read line; do
561 [[ -z ${line} ]] && continue
562 if ! _qt_built_with_use ${line}; then
563 missing=true
564 fi
565 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
566 if [[ -n ${missing} ]]; then
567 echo
568 eerror "Flags marked with an * are missing."
569 die "Missing USE flags found"
570 fi
571} 745}
572 746
573# @FUNCTION: qt_mkspecs_dir 747# @FUNCTION: qt_mkspecs_dir
574# @RETURN: the specs-directory w/o path 748# @RETURN: the specs-directory w/o path
575# @DESCRIPTION: 749# @DESCRIPTION:
576# Allows us to define which mkspecs dir we want to use. 750# Allows us to define which mkspecs dir we want to use.
577qt_mkspecs_dir() { 751qt_mkspecs_dir() {
578 # Allows us to define which mkspecs dir we want to use.
579 local spec 752 local spec=
580
581 case ${CHOST} in 753 case ${CHOST} in
582 *-freebsd*|*-dragonfly*) 754 *-freebsd*|*-dragonfly*)
583 spec="freebsd" ;; 755 spec=freebsd ;;
584 *-openbsd*) 756 *-openbsd*)
585 spec="openbsd" ;; 757 spec=openbsd ;;
586 *-netbsd*) 758 *-netbsd*)
587 spec="netbsd" ;; 759 spec=netbsd ;;
588 *-darwin*) 760 *-darwin*)
761 if use aqua; then
762 # mac with carbon/cocoa
763 spec=macx
764 else
765 # darwin/mac with x11
589 spec="darwin" ;; 766 spec=darwin
767 fi
768 ;;
769 *-solaris*)
770 spec=solaris ;;
590 *-linux-*|*-linux) 771 *-linux-*|*-linux)
591 spec="linux" ;; 772 spec=linux ;;
592 *) 773 *)
593 die "Unknown CHOST, no platform choosen." 774 die "Unknown CHOST, no platform chosen"
594 esac 775 esac
595 776
596 CXX=$(tc-getCXX) 777 CXX=$(tc-getCXX)
597 if [[ ${CXX/g++/} != ${CXX} ]]; then 778 if [[ ${CXX} == *g++* ]]; then
598 spec="${spec}-g++" 779 spec+=-g++
599 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 780 elif [[ ${CXX} == *icpc* ]]; then
600 spec="${spec}-icc" 781 spec+=-icc
601 else 782 else
602 die "Unknown compiler ${CXX}." 783 die "Unknown compiler '${CXX}'"
784 fi
785
786 # Add -64 for 64bit profiles
787 if use x64-freebsd ||
788 use amd64-linux ||
789 use x64-macos ||
790 use x64-solaris ||
791 use sparc64-solaris
792 then
793 spec+=-64
603 fi 794 fi
604 795
605 echo "${spec}" 796 echo "${spec}"
606} 797}
607 798
608case ${EAPI:-0} in 799# @FUNCTION: qt_assistant_cleanup
609 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 800# @INTERNAL
801# @DESCRIPTION:
802# Tries to clean up tools.pro for qt-assistant ebuilds.
803# Meant to be called in src_prepare().
804# Since Qt 4.7.4 this function is a no-op.
805qt_assistant_cleanup() {
806 # apply patching to qt-assistant ebuilds only
807 [[ ${PN} != "qt-assistant" ]] && return
808
809 # no longer needed for 4.7.4 and later
810 version_is_at_least "4.7.4" && return
811
812 # different versions (and branches...) may need different handling,
813 # add a case if you need special handling
814 case "${MY_PV_EXTRA}" in
815 *kde-qt*)
816 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
817 -e "/mac/,/^embedded.*makeqpf$/d" \
818 -i tools/tools.pro || die "patching tools.pro failed"
819 ;;
820 *)
821 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
822 -e "/mac/,/^embedded.*makeqpf$/d" \
823 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
824 -i tools/tools.pro || die "patching tools.pro failed"
825 ;;
826 esac
827}
828
829# @FUNCTION: qt_nolibx11
830# @INTERNAL
831# @DESCRIPTION:
832# Ignore X11 tests for packages that don't need X libraries installed.
833qt_nolibx11() {
834 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
835 die "x11 check sed failed"
836}
837
610 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 838EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
611esac

Legend:
Removed from v.1.35  
changed lines
  Added in v.1.117

  ViewVC Help
Powered by ViewVC 1.1.20